# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormValidationMessage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'field_id': 'str',
        'severity': 'str',
        'validation_type': 'str',
        'message': 'str'
    }

    attribute_map = {
        'field_id': 'fieldId',
        'severity': 'severity',
        'validation_type': 'validationType',
        'message': 'message'
    }

    def __init__(self, field_id=None, severity=None, validation_type=None, message=None):  # noqa: E501
        """FormValidationMessage - a model defined in Swagger"""  # noqa: E501
        self._field_id = None
        self._severity = None
        self._validation_type = None
        self._message = None
        self.discriminator = None
        if field_id is not None:
            self.field_id = field_id
        if severity is not None:
            self.severity = severity
        if validation_type is not None:
            self.validation_type = validation_type
        if message is not None:
            self.message = message

    @property
    def field_id(self):
        """Gets the field_id of this FormValidationMessage.  # noqa: E501


        :return: The field_id of this FormValidationMessage.  # noqa: E501
        :rtype: str
        """
        return self._field_id

    @field_id.setter
    def field_id(self, field_id):
        """Sets the field_id of this FormValidationMessage.


        :param field_id: The field_id of this FormValidationMessage.  # noqa: E501
        :type: str
        """

        self._field_id = field_id

    @property
    def severity(self):
        """Gets the severity of this FormValidationMessage.  # noqa: E501


        :return: The severity of this FormValidationMessage.  # noqa: E501
        :rtype: str
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this FormValidationMessage.


        :param severity: The severity of this FormValidationMessage.  # noqa: E501
        :type: str
        """
        allowed_values = ["error", "warn", "info"]  # noqa: E501
        if severity not in allowed_values:
            raise ValueError(
                "Invalid value for `severity` ({0}), must be one of {1}"  # noqa: E501
                .format(severity, allowed_values)
            )

        self._severity = severity

    @property
    def validation_type(self):
        """Gets the validation_type of this FormValidationMessage.  # noqa: E501


        :return: The validation_type of this FormValidationMessage.  # noqa: E501
        :rtype: str
        """
        return self._validation_type

    @validation_type.setter
    def validation_type(self, validation_type):
        """Sets the validation_type of this FormValidationMessage.


        :param validation_type: The validation_type of this FormValidationMessage.  # noqa: E501
        :type: str
        """
        allowed_values = ["MANDATORY_FIELD", "ORPHAN_FIELD", "CONSTRAINT_VIOLATION", "DATA_TYPE_AND_DISPLAY_MISMATCH", "FIELD_DEFINITION_MISMATCH", "NOT_SUPPORTED_FIELD_TYPE", "SCHEMA_AND_DEFAULT_VALUE_STRUCTURE_MISMATCH", "EXTERNAL_VALIDATION", "DEFAULT_VALUE_MISSING_REQUIRED_FIELDS"]  # noqa: E501
        if validation_type not in allowed_values:
            raise ValueError(
                "Invalid value for `validation_type` ({0}), must be one of {1}"  # noqa: E501
                .format(validation_type, allowed_values)
            )

        self._validation_type = validation_type

    @property
    def message(self):
        """Gets the message of this FormValidationMessage.  # noqa: E501


        :return: The message of this FormValidationMessage.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this FormValidationMessage.


        :param message: The message of this FormValidationMessage.  # noqa: E501
        :type: str
        """

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormValidationMessage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormValidationMessage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
